-- vim: ts=2 sw=2 ai et enc=utf8 fenc=utf8
local NAME, PAL = ...

local L = PetAbilityList_Locale

local Abilities = {
  Ferocity = {
    { name = L.CARRIONBIRDS , basic = 17253, special = 24423, exotic = nil,   bonus = nil   },
    { name = L.CATS         , basic = 16827, special = 93435, exotic = nil,   bonus = 24450 },
    { name = L.COREHOUNDS   , basic = 17253, special = 58604, exotic = 90355, bonus = nil   },
    { name = L.DEVILSAURS   , basic = 17253, special = 90309, exotic = 54680, bonus = nil   },
    { name = L.DOGS         , basic = 17253, special = 90327, exotic = nil,   bonus = nil   },
    { name = L.FOXES        , basic = 17253, special = 90314, exotic = nil,   bonus = 90347 },
    { name = L.HYENAS       , basic = 17253, special = 50271, exotic = nil,   bonus = nil   },
    { name = L.MOTHS        , basic = 49966, special = 50318, exotic = nil,   bonus = nil   },
    { name = L.RAPTORS      , basic = 16827, special = 50498, exotic = nil,   bonus = nil   },
    { name = L.SPIRITBEASTS , basic = 16827, special = 93435, exotic = 90361, bonus = 90328 },
    { name = L.TALLSTRIDERS , basic = 16827, special = 50285, exotic = nil,   bonus = nil   },
    { name = L.WASPS        , basic = 49966, special = 56626, exotic = nil,   bonus = nil   },
    { name = L.WOLVES       , basic = 17253, special = 24604, exotic = nil,   bonus = nil   },
  },
  Cunning = {
    { name = L.BATS         , basic = 17253, special = 50519, exotic = nil,   bonus = nil   },
    { name = L.BIRDSOFPREY  , basic = 16827, special = 91644, exotic = nil,   bonus = 94022 },
    { name = L.CHIMAERAS    , basic = 17253, special = 54644, exotic = 92380, bonus = nil   }, -- Or 95725?
    { name = L.DRAGONHAWKS  , basic = 17253, special = 34889, exotic = nil,   bonus = nil   },
    { name = L.MONKEYS      , basic = 49966, special = 90337, exotic = nil,   bonus = nil   },
    { name = L.NETHERRAYS   , basic = 17253, special = 50479, exotic = nil,   bonus = nil   },
    { name = L.RAVAGERS     , basic = 17253, special = 50518, exotic = nil,   bonus = nil   },
    { name = L.SERPENTS     , basic = 17253, special = 35387, exotic = nil,   bonus = nil   }, -- Or 95466?
    { name = L.SILITHIDS    , basic = 16827, special = 54706, exotic = 90364, bonus = nil   },
    { name = L.SPIDERS      , basic = 17253, special =  4167, exotic = nil,   bonus = nil   },
    { name = L.SPOREBATS    , basic = 49966, special = 50274, exotic = nil,   bonus = nil   },
    { name = L.WINDSERPENTS , basic = 17253, special = 24844, exotic = nil,   bonus = nil   },
  },
  Tenacity = {
    { name = L.BEARS        , basic = 16827, special = 50256, exotic = nil,   bonus = 94019 },
    { name = L.BEETLES      , basic = 17253, special = 90339, exotic = nil,   bonus = nil   },
    { name = L.BOARS        , basic = 17253, special = 35290, exotic = nil,   bonus = nil   },
    { name = L.CRABS        , basic = 16827, special = 50245, exotic = nil,   bonus = nil   },
    { name = L.CROCOLISKS   , basic = 17253, special = 50433, exotic = nil,   bonus = nil   },
    { name = L.GORILLAS     , basic = 49966, special = 26090, exotic = nil,   bonus = nil   },
    { name = L.RHINOS       , basic = 49966, special = 57386, exotic = 93434, bonus = nil   },
    { name = L.SCORPIDS     , basic = 16827, special = 50541, exotic = nil,   bonus = nil   },
    { name = L.SHALESPIDERS , basic = 17253, special = 52086, exotic = 90363, bonus = nil   },
    { name = L.TURTLES      , basic = 17253, special = 26064, exotic = nil,   bonus = nil   },
    { name = L.WARPSTALKERS , basic = 17253, special = 35346, exotic = nil,   bonus = nil   },
    { name = L.WORMS        , basic = 17253, special = 55749, exotic = 93433, bonus = nil   }, -- Or 95714? Or even 95711?
  }
}

local SameEffects = {
  [24450] = { L.SPIRITBEASTS }, -- Cats (bonus)
  [90328] = { L.CATS }, -- Spirit Beasts (bonus)
  [93435] = { L.CATS, L.SPIRITBEASTS }, -- Cat & Spirit Beasts have exactly same ability
  [24604] = { L.DEVILSAURS }, -- Wolves
  [90309] = { L.WOLVES }, -- Devilsaurs
  [50518] = { L.WORMS }, -- Ravagers
  [55749] = { L.RAVAGERS }, -- Worms
  [34889] = { L.WINDSERPENTS }, -- Dragonhawks
  [24844] = { L.DRAGONHAWKS }, -- Windserpents
  [50271] = { L.BOARS, L.RHINOS }, -- Hyenas
  [35290] = { L.HYENAS, L.RHINOS }, -- Boars
  [57386] = { L.BOARS, L.HYENAS }, -- Rhinos
  [90314] = { L.TALLSTRIDERS }, -- Foxes
  [50285] = { L.FOXES }, -- Tallstriders
  [50274] = { L.COREHOUNDS }, -- Sporebat
  [58604] = { L.SPOREBATS }, -- Core Hounds
  [24423] = { L.BEARS }, -- Carrion Birds
  [50256] = { L.CARRIONBIRDS }, -- Bears
  [50498] = { L.SERPENTS }, -- Raptors
  [35387] = { L.RAPTORS }, -- Serpents
  [91644] = { L.SCORPIDS }, -- Birds of Prey
  [50541] = { L.BIRDSOFPREY }, -- Scorpids
  [90327] = { L.CRABS }, -- Dogs
  [50245] = { L.DOGS }, -- Crabs
  [50519] = { L.WASPS }, -- Bats
  [56626] = { L.BATS }, -- Wasps
  [50318] = { L.NETHERRAYS, L.GORILLAS }, -- Moths (longer lockout for Moths though)
  [50479] = { L.MOTHS, L.GORILLAS }, -- Nether Rays
  [26090] = { L.MOTHS, L.NETHERRAYS }, -- Gorillas
  [54706] = { L.SPIDERS }, -- Silithids
  [ 4167] = { L.SILITHIDS }, -- Spiders
  [90339] = { L.TURTLES }, -- Beetles
  [26064] = { L.BEETLES }, -- Turtles
  [54644] = { L.CROCOLISKS, L.WARPSTALKERS }, -- Chimaeras
  [50433] = { L.CHIMAERAS, L.WARPSTALKERS }, -- Crocolisk
  [35346] = { L.CHIMAERAS, L.CROCOLISKS }, -- Warp Stalker
}


local function make_text_entry (parent, relto, text, small)
  local e = CreateFrame ("Frame", nil, parent)
  e:SetPoint ("TOPLEFT", relto, "BOTTOMLEFT")
  e:SetPoint ("RIGHT", parent, "RIGHT")
  local fsize = "GameFontNormal"
  if small then fsize = fsize.."Small" end
  local txt = e:CreateFontString (nil, "ARTWORK", fsize)
  txt:SetPoint ("TOPLEFT", e, "TOPLEFT")
  txt:SetPoint ("RIGHT", e, "RIGHT")
  txt:SetJustifyH ("LEFT")
  txt:SetText (text)
  e:SetHeight (22)
  e:EnableMouse (true)
  e.txt = txt
  return e
end

local function do_tooltip_show (frame)
  GameTooltip:SetOwner (frame, "ANCHOR_RIGHT", 0, -20)
  GameTooltip:SetSpellByID (frame.spellid)
  local also = SameEffects[frame.spellid]
  if also then
    GameTooltip:AddLine ("\n|cffffffff"..L.SEEALSO.."|r\n "..table.concat (also, "\n "))
  end
  GameTooltip:Show ()
end

local function do_tooltip_hide (frame)
  GameTooltip:Hide ()
end

local function do_link_spell (frame, button)
  if button == "LeftButton" and IsShiftKeyDown () then
    ChatEdit_InsertLink (GetSpellLink (frame.spellid))
  end
end

local function make_spell_entry (parent, relto, spellid)
  if not spellid then
    return make_text_entry (parent, relto, " ")
  end

  local sname, _, sicon = GetSpellInfo (spellid)
  local e = make_text_entry (parent, relto, sname, true)
  e.spellid = spellid
  local tex = e:CreateTexture (nil, "ARTWORK")
  tex:SetTexture (sicon)
  tex:SetPoint ("TOPLEFT", e, "TOPLEFT")
  tex:SetPoint ("BOTTOM", e, "BOTTOM")
  tex:SetSize (20, 20)
  e.icon = tex
  e.txt:ClearAllPoints ()
  e.txt:SetPoint ("LEFT", tex, "RIGHT", 4, 0)
  e.txt:SetPoint ("RIGHT", e, "RIGHT")
  e:SetScript ("OnEnter", do_tooltip_show)
  e:SetScript ("OnLeave", do_tooltip_hide)
  e:SetScript ("OnMouseDown", do_link_spell)
  return e
end


local function make_list (framename, list)
  local pframe = _G[framename]
  if not pframe then return end
  local col_name = _G[framename.."Name"]
  local col_basic = _G[framename.."Basic"]
  local col_special = _G[framename.."Special"]
  local col_exotic = _G[framename.."Exotic"]
  local col_bonus = _G[framename.."Bonus"]

  local top_name, top_basic, top_special, top_exotic, top_bonus
  local link_name, link_basic, link_special, link_exotic, link_bonus
  for _, family in ipairs (list) do
    link_name = make_text_entry (col_name, link_name or col_name, family.name, false)
    link_basic = make_spell_entry (col_basic, link_basic or col_basic, family.basic)
    link_special = make_spell_entry (col_special, link_special or col_special, family.special)
    link_exotic = make_spell_entry (col_exotic, link_exotic or col_exotic, family.exotic)
    link_bonus = make_spell_entry (col_bonus, link_bonus or col_bonus, family.bonus)
    if not top_name then
      top_name = link_name
      top_basic = link_basic
      top_special = link_special
      top_exotic = link_exotic
      top_bonus = link_bonus
    end
  end

  local hdr_name, hdr_basic, hdr_special, hdr_exotic, hdr_bonus
  hdr_name = make_text_entry (col_name, col_name, L.FAMILY)
  hdr_basic = make_text_entry (col_basic, col_basic, L.BASIC)
  hdr_special = make_text_entry (col_special, col_special, L.SPECIAL)
  hdr_exotic = make_text_entry (col_exotic, col_exotic, L.EXOTIC)
  hdr_bonus = make_text_entry (col_bonus, col_bonus, L.BONUS)
  for _, hdr in ipairs ({ hdr_name, hdr_basic, hdr_special, hdr_exotic, hdr_bonus }) do
    hdr.txt:SetTextColor (1, 1, 1, 1)
  end

  local xoffs, yoffs = 20, -50
  hdr_name:SetPoint ("TOPLEFT", col_name, "TOPLEFT", xoffs, yoffs + 24)
  hdr_basic:SetPoint ("TOPLEFT", col_basic, "TOPLEFT", xoffs, yoffs + 24)
  hdr_special:SetPoint ("TOPLEFT", col_special, "TOPLEFT", xoffs, yoffs + 24)
  hdr_exotic:SetPoint ("TOPLEFT", col_exotic, "TOPLEFT", xoffs, yoffs + 24)
  hdr_bonus:SetPoint ("TOPLEFT", col_bonus, "TOPLEFT", xoffs, yoffs + 24)

  top_name:SetPoint ("TOPLEFT", col_name, "TOPLEFT", xoffs, yoffs)
  top_basic:SetPoint ("TOPLEFT", col_basic, "TOPLEFT", xoffs, yoffs +4)
  top_special:SetPoint ("TOPLEFT", col_special, "TOPLEFT", xoffs, yoffs +4)
  top_exotic:SetPoint ("TOPLEFT", col_exotic, "TOPLEFT", xoffs, yoffs +4)
  top_bonus:SetPoint ("TOPLEFT", col_bonus, "TOPLEFT", xoffs, yoffs +4)
end

function PALpopulateLists ()
  make_list ("PALframeTabPage1", Abilities.Ferocity)
  make_list ("PALframeTabPage2", Abilities.Cunning)
  make_list ("PALframeTabPage3", Abilities.Tenacity)
  
  if L.LOGINMSG then
    DEFAULT_CHAT_FRAME:AddMessage ("<Anyia's Pet Ability List>"..L.LOGINMSG.."|cffffffff/pal|r", 0, 0.8, 0)
  end
end


SlashCmdList.PETABILITYLIST = function ()
  if PALframe:IsVisible () then
    PALframe:Hide ()
  else
    PALframe:Show ()
  end
end
SLASH_PETABILITYLIST1 = "/pal"
SLASH_PETABILITYLIST2 = "/petability"
SLASH_PETABILITYLIST3 = "/petabilitylist"

-- Close on Escape
tinsert (UISpecialFrames, "PALframe")

-- If we have LibStub and DataBroker, use it!
if LibStub then
  local ldb = LibStub:GetLibrary("LibDataBroker-1.1", true)
  if ldb then
    local dataobj = ldb:NewDataObject (NAME, {
      type = 'launcher',
      icon = "Interface\\Icons\\Ability_Druid_FerociousBite",
      OnClick = function (self, button, ...)
        PALframe:Show ()
      end,
      text = NAME,
      tocname = 'PetAbilityList'
    })
  end
end


-- Keybindings
BINDING_HEADER_PETABILITYLIST = "Anyia's Pet Ability List"
BINDING_NAME_PETABILITYLIST_TOGGLE = "Toggle Pet Ability List"

